/*
 * Part 3 of the mined editor.
 */

/*  ========================================================================  *
 *				Kanji Commands											      *
 *  ========================================================================  */

#include "mined.h"

kadjust()
{
  if (Iskanj2(cur_line->text, cur_text))
    move_to(x - 1, y);
}

Iskanj1(s, t)
char *s, *t;
{
  return !Iskanj2(s, t) && Iskanji(*t);
}

Iskanj2(s, t)
char *s, *t;
{
  for ( ; s < t; s++)
    if (Iskanji(*s))
      s++;
  return (s > t) ? 1 : 0;
}

#ifdef EUC
Iskanji(c)
char c;
{
  if(c & 0x80)
    return 1;
  return 0;
}
#else		/* default : Shift JIS */
Iskanji(c)
char c;
{
  unsigned int c1;
  c1 = (unsigned int)(c & 0xff);
  if ((c1 > 0x7f && c1 < 0xa0) || (c1 > 0xdf && c1 < 0xfd))
    return 1;
  return 0;
}
#endif /* EUC */

/* Toggle for KANJI input line at y = YMAX */
KINP()
{
#ifdef NO_KMODE	/* Escape from BUG for "-DUNIX -DKANJI" */
  status_line("Cannot use the KANJI input mode!", NIL_PTR);
#else
  if (ymax == YMAX)
    ymax = YMAX - 1;
  else
    ymax = YMAX;
  screenmax = ymax - 1;
  if (y > screenmax)		/* Out of screenmax */
    y = screenmax;
  reset(top_line, y);		/* Reset the bot_line */
  RD();				/* Redraw screen */
  if (ymax == YMAX)
    status_line("Shift to NORMAL input mode.", NIL_PTR);
  else
    status_line("Shift to KANJI input mode.", NIL_PTR);  
#endif /* NO_LMODE */
}
